# Test coverage parameters

This differs from *test execution reports*, which describe which tests within your test suite have been run during a build. For details, see [test-execution-parameters](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/test-execution-parameters "mention").

Test coverage reports are not generated by SonarQube Community Build itself. They must be generated by an external tool and then imported into SonarQube Community Build by specifying a parameter telling the scanner where to look for the report. The data is then displayed in your SonarQube Community Build analysis.

Below, you will find language- and tool-specific analysis parameters for importing test coverage reports.

For information on analysis parameters in general, see [analysis-parameters](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/analysis-parameters "mention").

Unless otherwise specified, these properties require values that are relative to the project root. Some properties support the following wildcards in paths. The remarks for properties that support wildcards will mention this fact. If wildcards are not noted for a given property, then they are not supported for that property.

|            |                           |
| ---------- | ------------------------- |
| **Symbol** | **Meaning**               |
| `?`        | a single character        |
| `*`        | any number of characters  |
| `**`       | any number of directories |

## All languages <a href="#all-languages" id="all-languages"></a>

`sonar.coverageReportPaths`

* Comma-delimited list of paths to coverage reports in the [generic-test-data](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/generic-test-data "mention") format.

## Flex <a href="#flex" id="flex"></a>

`sonar.flex.cobertura.reportPaths`

* Path to the Cobertura XML reports. Multiple paths may be comma-delimited. May be absolute or relative to the project base directory.

## Go <a href="#go" id="go"></a>

`sonar.go.coverage.reportPaths`

* Comma-delimited list of paths to coverage report files. Wildcards are supported.

## Java/Kotlin/Scala/JVM <a href="#java" id="java"></a>

See [java-test-coverage](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/java-test-coverage "mention") for examples and details.

`sonar.coverage.jacoco.xmlReportPaths`

* Comma-delimited list of paths to JaCoCo XML coverage reports. Wildcards are supported.

`sonar.jacoco.reportPaths`

* Deprecated. Use `sonar.coverage.jacoco.xmlReportPaths` instead.

## JavaScript/TypeScript <a href="#javascript-typescript" id="javascript-typescript"></a>

See [javascript-typescript-test-coverage](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/javascript-typescript-test-coverage "mention") for examples and details.

`sonar.javascript.lcov.reportPaths`

* Comma-delimited list of paths to LCOV coverage report files. Paths may be absolute or relative to the project root.

## PHP <a href="#php" id="php"></a>

See [php-test-coverage](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/php-test-coverage "mention") for examples and details.

`sonar.php.coverage.reportPaths`

* Comma-delimited list of paths to Clover XML-format coverage report files. Paths may be absolute or relative to the project root.

## Python <a href="#python" id="python"></a>

See [python-test-coverage](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/python-test-coverage "mention") for examples and details.

`sonar.python.coverage.reportPaths`

* Comma-delimited list of paths to coverage reports in the Cobertura XML format. Wildcards are supported. Leave unset to use the default, `coverage-reports/*coverage-*.xml`.

## Ruby <a href="#ruby" id="ruby"></a>

`sonar.ruby.coverage.reportPaths`

* Comma-delimited list of paths to SimpleCov report files generated with the [JSON formatter](https://github.com/simplecov-ruby/simplecov#json-formatter) (available from SimpleCov 0.20). For SimpleCov versions before 0.18, you can provide `.resultset.json` report files (though we recommend updating to 0.20 and using the JSON formatter). Paths may be absolute or relative to the project root.
* When using the `simplecov_json_formatter` from simplecov >= v0.20, add\
  `-D sonar.ruby.coverage.reportPaths=coverage/coverage.json \` to your SonarScanner code.

## Scala <a href="#scala" id="scala"></a>

`sonar.scala.coverage.reportPaths`

* Comma-delimited list of paths to `scoverage.xml` report files generated by Scoverage.

## VB.NET <a href="#vb-dotnet" id="vb-dotnet"></a>

See [dotnet-test-coverage](https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/dotnet-test-coverage "mention") for examples and details.

`sonar.vbnet.vscoveragexml.reportsPaths`

* Comma-delimited list of paths to Visual Studio Code Coverage reports. Wildcards are supported.

`sonar.vbnet.dotcover.reportsPaths`

* Comma-delimited list of paths to dotCover coverage reports.

`sonar.vbnet.opencover.reportsPaths`

* Comma-delimited list of paths to OpenCover coverage reports.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sonarsource.com/sonarqube-community-build/analyzing-source-code/test-coverage/test-coverage-parameters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
